/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"
#include <stdio.h>

#define CYBLE_MOTOR_INC_DEC_SPEED_CHAR_HANDLE   (0x0016u)  /* Handle of INC_DEC_SPEED characteristic */
#define CYBLE_MOTOR_START_STOP_CLIENT_CHARACTERISTIC_CONFIGURATION_DESC_HANDLE   (0x0014u) /* Handle of Client Characteristic Configuration descriptor */





int _write(int file, char *ptr, int len)
{
    int i;
    file = file;
    for (i = 0; i < len; i++)
    {
      UART_UartPutChar(*ptr++);
    }
    return len;
}




uint8 data=1,k;
CYBLE_GAP_BD_ADDR_T peerdevice;
uint32 device;
uint8 flag;

CY_ISR_PROTO(pin_Handler);

CY_ISR(pin_Handler)
{
    flag++;    
    Pin_ClearInterrupt();   
    isr_1_ClearPending();
    
    /* If flag=1 scanning starts */
    
    if(flag==1)
    {       
        printf(" \r\n start scannning \r\n ");
        CyBle_GapcStartScan(CYBLE_SCANNING_FAST);
        CyBle_ProcessEvents();
    }
   
}

void stackevent(uint32 event, void *eventParam)
{ 
    CYBLE_GAPC_ADV_REPORT_T scanreport;
    
    CYBLE_API_RESULT_T apiResult;
   
    CYBLE_GATTC_WRITE_REQ_T  writereq;

    
    switch(event)
    {
        case CYBLE_EVT_STACK_ON:
        
        break;
       
        
        case CYBLE_EVT_GAPC_SCAN_PROGRESS_RESULT:
        
        scanreport= *(CYBLE_GAPC_ADV_REPORT_T*) eventParam;
        
         /* Comparing the ScanResponse data with Scan report data and then connected */
        
        if(scanreport.data[1]==0x0FF  && scanreport.data[2]==0x31  && scanreport.data[3]==0x01  && 
        scanreport.data[4]==0x66 && scanreport.data[5]==0x77)
        {
            for(k=0;k<6;k++)
            {
            peerdevice.bdAddr[k]=scanreport.peerBdAddr[k];
            }
            device=1;
        printf(" \r\n device detected \r\n ");
            CyBle_GapcStopScan();
            CyBle_ProcessEvents();
        }
        break;
        
        
        case CYBLE_EVT_GAPC_SCAN_START_STOP:

          if(CyBle_GetState()==CYBLE_STATE_SCANNING)
              {
                    printf("Started to Scan\r\n");
                }
                else if(CyBle_GetState()==CYBLE_STATE_DISCONNECTED)
                {    
                    printf("Stop scanning:\r\n");
                    if(device==1)
                    {
                        apiResult=CyBle_GapcConnectDevice(&peerdevice);
                        if(apiResult==CYBLE_ERROR_OK)
                        {
                            printf("success\r\n");
                        }
                        else 
                        {
                            printf("connection failed:%x\r\n",apiResult);
                        }
                        device=0;   
                    }
                }
   
          break;
        
                
        case CYBLE_EVT_GAP_DEVICE_CONNECTED :   
         printf(" \r\n connection established \r\n ");
        break;
     
        
        case CYBLE_EVT_GAP_DEVICE_DISCONNECTED:
        printf(" \r\n device disconnected \r\n ");
        
        CyBle_GapcStartScan(CYBLE_SCANNING_SLOW);
                    
        break;

        
       case CYBLE_EVT_GATTC_WRITE_RSP:
   
        data++;
        
         if(data==9)
        {
            data=0;
        }      
        break;
      }
}

int main(void)
{
    CyGlobalIntEnable; /* Enable global interrupts. */
  
    flag=0;
  
    isr_1_StartEx(pin_Handler);

    CYBLE_GATTC_WRITE_REQ_T  writereq;
    CYBLE_CONN_HANDLE_T connt;
    CyBle_Start(stackevent);
    UART_Start();

    printf("starting the central:");
    
    CyBle_ProcessEvents();
   
    for(;;)
    {
      /* Place your application code here. */
        
        CyBle_ProcessEvents();
        
        /* If flag=2 then the data is writing into the peripheral contineously. 
          In the peripheral side we can see the LED breathing. 
          This data value will contineouly change the compare value of the PWM in the Peripheral */
        
        if(flag==2)
        {
            writereq.attrHandle=CYBLE_MOTOR_INC_DEC_SPEED_CHAR_HANDLE;
            writereq.value.val=&data;
            writereq.value.len=sizeof(data);            
            CyBle_GattcWriteCharacteristicValue(cyBle_connHandle, &writereq);
        }
        
    }
}