/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#include "project.h"

uint8 notify1,notify2,flag1,flag2;
//
void stackeventhandler(uint32 event, void *eventParam)
{
    CYBLE_STATE_T state;
    CYBLE_GATTS_WRITE_REQ_PARAM_T *wrReqParam; 
switch(event)
{
    
    case CYBLE_EVT_STACK_ON:
    
    CyBle_GappStartAdvertisement(CYBLE_ADVERTISING_FAST);
    
    break;
    
    case CYBLE_EVT_GAPP_ADVERTISEMENT_START_STOP:
    
    if(state!=CYBLE_STATE_ADVERTISING)
    {
    CyBle_GappStartAdvertisement(CYBLE_ADVERTISING_SLOW);
    }
    break;
    case CYBLE_EVT_GAP_DEVICE_DISCONNECTED:
    
    PWM_WriteCompare(0);
    
    PWM_Stop();
    Pin_Write(1);
    CyBle_GappStartAdvertisement(CYBLE_ADVERTISING_FAST);
    
    break;
    case CYBLE_EVT_GAP_DEVICE_CONNECTED:
    
    Pin_Write(0);
    
    break;
    case CYBLE_EVT_GATTS_WRITE_REQ:
  
    wrReqParam = (CYBLE_GATTS_WRITE_REQ_PARAM_T *) eventParam;
    
    
    /* Checking for START_STOP Characteristic enable */
    
    if(wrReqParam->handleValPair.attrHandle==CYBLE_MOTOR_START_STOP_CLIENT_CHARACTERISTIC_CONFIGURATION_DESC_HANDLE)
    {
        notify1=wrReqParam->handleValPair.value.val[0];
        flag1=1;
        
    }
    /* Checking for INC_DEC_SPEED Characteristic enable */
    
    if(wrReqParam->handleValPair.attrHandle==CYBLE_MOTOR_INC_DEC_SPEED_CHAR_HANDLE)
    {
    notify2=wrReqParam->handleValPair.value.val[0];
    flag2=1;
    
    /*Writing the data from BLE central (Mobile) to BLE peripheral */
    
    CyBle_GattsWriteAttributeValue(&wrReqParam->handleValPair,0,&cyBle_connHandle,0);
 
    }
    CyBle_GattsWriteRsp(cyBle_connHandle);
       
    break;
}

}

int main(void)
{
    CyGlobalIntEnable; /* Enable global interrupts. */

    CyBle_Start(stackeventhandler);
    
    /* Place your initialization/startup code here (e.g. MyInst_Start()) */

    for(;;)
    {
        
        CyBle_ProcessEvents();
               
        if(flag1==1)
        {   
            flag1=0;
            PWM_Start();    
              
            if(notify1==1)    
            {                      
                
                PWM_WriteCompare(0);                 
            }
            else if(notify1==0)
            {
            PWM_WriteCompare(3000);
            }
        }
 
        if(flag2==1)
      
        {
          flag2=0;
          PWM_Start();
          
          if(notify2)
        {
        PWM_WriteCompare(300*notify2);
        }
        else if(notify2==0)
        {
        PWM_WriteCompare(3000); 
        }
        
     }
   
  }

}




/* [] END OF FILE */
